
public abstract class ExpressaoBinaria  implements Expressao{

	Expressao exp1;
	Expressao exp2;
	char operador;

	public int altura() {
		return 1 + Math.max(this.exp1.altura(), this.exp2.altura());
	}


	public int numeroOperadores() {
		return 1 + this.exp1.numeroOperadores() + this.exp2.numeroOperadores();
	}

	public Lista subExpressoes() {
		Lista retorno = this.exp1.subExpressoes();
		Lista lista2 = this.exp2.subExpressoes();
		if(!lista2.isEmpty()){
			No atual = lista2.first;
			while(atual!= null){
				String s = atual.getExpressao();
				if(!retorno.contains(s)){
					retorno.inserir(s);
				}
				atual = atual.getNext();
			}

		}
		retorno.inserir(this.representacao());
		return retorno;
	}

	public boolean existeX(){
		return  this.representacao().contains("x");
	}

	public boolean existeY(){
		return  this.representacao().contains("y");
	}

	public boolean existeZ(){
		return  this.representacao().contains("z");
	}

	public int numeroSubExp(){
		Lista lista = this.subExpressoes();
		int i = 0;
		if(!lista.isEmpty()){
			No atual = lista.first;
			while(atual!=null){
				atual = atual.getNext();
				i++;
			}
		}
		return i;
	}
		
		



}
