class No {
	private No next;
	private String expressao;

	public No(String expressao) {
		this.expressao = expressao;
	}

	public No getNext() {
		return next;
	}

	public void setNext(No prox) {
		this.next = prox;
	}

	public String getExpressao() {
		return this.expressao;
	}

	public void setExpressao(String expressao) {
		this.expressao = expressao;
	}

}

public class Lista {
	public No first;

	public boolean isEmpty() {
		return this.first == null;
	}

	public void inserir(String expressao) {
		No no = new No(expressao);
		if (this.isEmpty()) {
			this.first = no;
		} else {
			No emp = this.first;
			while (emp.getNext() != null) {
				emp = emp.getNext();
			}
			emp.setNext(no);
		}
	}

	/**
	 * Se for pilha!
	 * 
	 * @return
	 */
	public String remover() {
		String exp = this.first.getExpressao();
		this.first = this.first.getNext();
		return exp;
	}

	public boolean contains(String exp) {
		String s = exp;
		boolean output = false;
		if (!this.isEmpty()) {
			No atual = this.first;
			while (atual != null && !output) {
				String daVez = atual.getExpressao();
				if (s.equals(daVez)) {
					output = true;
				}
				atual = atual.getNext();
			}
		}
		return output;
	}

	public String toString() {
		String output = "";
		if (!this.isEmpty()) {
			No atual = this.first;
			while (atual != null) {
				String daVez = atual.getExpressao();
				output = output + daVez + " ";
				atual = atual.getNext();
			}
		}
		return output.trim();
	}

}
