public class ExpressaoAtomica implements Expressao {

	String simbolo;

	public ExpressaoAtomica(String s) {

		simbolo = s;

	}

	@Override
	public int altura() {

		return 0;
	}

	@Override
	public int numeroOperadores() {
		return 0;
	}

	@Override
	public String representacao() {
		return this.simbolo;
	}

	@Override
	public Lista subExpressoes() {
		Lista retorno = new Lista();
		retorno.inserir(this.representacao());
		return retorno;
	}

	@Override
	public boolean existeX() {
		return this.simbolo.equalsIgnoreCase("x");
	}

	@Override
	public boolean existeY() {
		return this.simbolo.equalsIgnoreCase("y");
	}

	@Override
	public boolean existeZ() {
		return this.simbolo.equalsIgnoreCase("z");
	}

	@Override
	public boolean getValoracao(boolean x, boolean y, boolean z) {

		if (simbolo.equalsIgnoreCase("x")) {
			return x;
		} else if (simbolo.equalsIgnoreCase("y")) {
			return y;
		} else if (simbolo.equalsIgnoreCase("z")) {
			return z;
		} else if (simbolo.equalsIgnoreCase("0")) {
			return false;
		} else {
			return true;
		}
	}

	@Override
	public int numeroSubExp() {
		return 1;
	}

	




}
