
public class Negacao implements Expressao{

	Expressao expressao1;
	
	public Negacao(Expressao a){
		this.expressao1 = a;
	}
	
	
	public int altura() {
		return 1 + this.expressao1.altura();
	}

	
	public int numeroOperadores() {
		return 1 + this.expressao1.numeroOperadores();
	}

	
	public String representacao() {
		return "(-" + this.expressao1.representacao() + ")";
	}

	
	public Lista subExpressoes() {
		Lista retorno = this.expressao1.subExpressoes();
		retorno.inserir(this.representacao());
		return retorno;
	}


	@Override
	public boolean existeX() {
		return this.expressao1.existeX();
	}


	@Override
	public boolean existeY() {
		return this.expressao1.existeY();
	}


	@Override
	public boolean existeZ() {
		return this.expressao1.existeZ();
	}


	@Override
	public boolean getValoracao(boolean x, boolean y, boolean z) {
		return !(this.expressao1.getValoracao(x, y, z));
	}


	@Override
	public int numeroSubExp() {
		
			Lista lista = this.subExpressoes();
			int i = 0;
			if(!lista.isEmpty()){
				No atual = lista.first;
				while(atual!=null){
					atual = atual.getNext();
					i++;
				}
			}
			return i;
	}
}
		

