
public class Principal{


	public boolean avaliarExpressao(String s){

		boolean retorno = true;
		char anterior = 'g';
		if(s.length() == 1){
			char c = s.charAt(0);
			if(!(c == 'x' || c == 'y' || c == 'z' || c == '0' || c== '1')){
				retorno = false;                  
			}
		}

		else{
			int abertos = 0;
			int fechados = 0;
			int numeroOp = 0;
			int delta = -1;
			boolean achouOpRaiz = false;
			for(int i = 0; i < s.length(); i++){
				if(s.charAt(i) == '('){
					abertos++;
					delta++;
					if(!(anterior == 'g' || anterior == '(' || anterior == '-' || anterior == '.' || anterior == '+') ){
						retorno = false;
						break;
					}
					anterior = '(';
				}
				else if(s.charAt(i) == ')'){
					fechados++;
					delta--;
					
						if(anterior == '+' ||anterior == '-' ||anterior == '.' || anterior == 'g'){
							retorno = false;
							break;
						}
					anterior = ')';
				}
				else if(s.charAt(i) == '+' || s.charAt(i) == '.'){
					numeroOp++;
					if(anterior == 'g' || anterior == '(' || anterior == '-' || anterior == '.' || anterior == '+'){
						retorno = false;
						break;
					}
					if(delta == 0){
						achouOpRaiz = true;
						retorno = retorno && this.avaliarExpressao(s.substring(1, i));
						retorno = retorno && this.avaliarExpressao(s.substring(i+1,s.length()-1));
					}
					anterior = s.charAt(i);
				}
				else if(s.charAt(i) == '-'){
					if(anterior != '('){
						retorno = false;
						break;
					}
					if(delta== 0){
						achouOpRaiz = true;
						retorno = retorno && this.avaliarExpressao(s.substring(i+1,s.length()-1));
					}
					numeroOp++;
					anterior = '-';
				}
				else if(!(s.charAt(i) == 'x' ||s.charAt(i) == 'y' ||s.charAt(i) == 'z' ||s.charAt(i) == '0' ||s.charAt(i) == '1')){
					retorno = false;
				}
				else{
					if(anterior == '-' && s.charAt(i+1) != ')'){
						retorno = false;
						break;
					}
					anterior = s.charAt(i);
				}
			}

			if(abertos != fechados){
				retorno = false;
			}
			if(numeroOp != abertos || numeroOp != fechados){
				retorno = false;
			}
			if(s.equals("")){
				retorno = false;
			}
			if(!achouOpRaiz){
				retorno = false;
			}
		}

		return retorno;
	}

	public Expressao criarExpressao(String s){

		Expressao ret = null;

		if(s.length() == 1){
			char c = s.charAt(0);
			ret =  new ExpressaoAtomica(c +"");
		}

		else{

			int delta = -1;
			for(int i = 0; i < s.length(); i++){
				if(s.charAt(i) == '('){
					delta++;
				}
				else if(s.charAt(i) == ')'){				
					delta--;
				}
				else if(s.charAt(i) == '+' || s.charAt(i) == '.'){

					if(delta == 0){
						if(s.charAt(i) == '+'){
							Expressao exp1 = this.criarExpressao(s.substring(1, i));
							Expressao exp2 = this.criarExpressao(s.substring(i+1, s.length() -1));
							ret = new ExpressaoOU(exp1,exp2);
						}
						else{
							Expressao exp1 = this.criarExpressao(s.substring(1, i));
							Expressao exp2 = this.criarExpressao(s.substring(i+1, s.length() -1));
							ret = new ExpressaoE(exp1,exp2);
						}
					}
				}
				else if(s.charAt(i) == '-'){
					if(delta == 0){
						Expressao exp = this.criarExpressao(s.substring(i+1, s.length() - 1));
						ret = new Negacao(exp);
					}
				}


			}
		}
		return ret;
	}	


	public String valoracoes(Expressao e){
		String retorno = "";
		boolean x = e.existeX();
		boolean y = e.existeY();
		boolean z = e.existeZ();
		boolean unico = false;
		if(!(x||y||z)){

		}
		else if(x && !y && !z){
			if(e.getValoracao(false, false, false)){
				retorno= retorno + "(X=0); ";
				
			}
			if(e.getValoracao(true, false, false)){
				retorno= retorno + "(X=1); ";
			
			}
		}
		else if(!x && y && !z){
			if(e.getValoracao(false, false, false)){
				retorno= retorno + "(Y=0); ";
			
			}
			if(e.getValoracao(false, true, false)){
				retorno= retorno + "(Y=1); ";
			
			}
		}
		else if(!x && !y && z){
			if(e.getValoracao(false, false, false)){
				retorno= retorno + "(Z=0); ";
			}
			if(e.getValoracao(false, false, true)){
				retorno= retorno + "(Z=1); ";
			}
		}
		else if(x && y && !z){
			if(e.getValoracao(false, false, false)){
				retorno= retorno + "(X=0, Y=0); ";
			}
			if(e.getValoracao(false, true, false)){
				retorno= retorno + "(X=0, Y=1); ";
			}
			if(e.getValoracao(true, false, false)){
				retorno= retorno + "(X=1, Y=0); ";
			}
			if(e.getValoracao(true, true, false)){
				retorno= retorno + "(X=1, Y=1); ";
			}
		}
		else if(x && !y && z){
			if(e.getValoracao(false, false, false)){
				retorno= retorno + "(X=0, Z=0); ";
			}
			if(e.getValoracao(false, false, true)){
				retorno= retorno + "(X=0, Z=1); ";
			}
			if(e.getValoracao(true, false, false)){
				retorno= retorno + "(X=1, Z=0); ";
			}
			if(e.getValoracao(true, false, true)){
				retorno= retorno + "(X=1, Z=1); ";
			}
		}
		else if(!x && y && z){
			if(e.getValoracao(false, false, false)){
				retorno= retorno + "(Y=0, Z=0); ";
			}
			if(e.getValoracao(false, false, true)){
				retorno= retorno + "(Y=0, Z=1); ";
			}
			if(e.getValoracao(false, true, false)){
				retorno= retorno + "(Y=1, Z=0); ";
			}
			if(e.getValoracao(false, true, true)){
				retorno= retorno + "(Y=1, Z=1); ";
			}
		}
		else if(x && y && z){
			if(e.getValoracao(false, false, false)){
				retorno= retorno + "(X=0, Y=0, Z=0); ";
			}
			if(e.getValoracao(false, false, true)){
				retorno= retorno + "(X=0, Y=0, Z=1); ";
			}
			if(e.getValoracao(false, true, false)){
				retorno= retorno + "(X=0, Y=1, Z=0); ";
			}
			if(e.getValoracao(false, true, true)){
				retorno= retorno + "(X=0, Y=1, Z=1); ";
			}
			if(e.getValoracao(true, false, false)){
				retorno= retorno + "(X=1, Y=0, Z=0); ";
			}
			if(e.getValoracao(true, false, true)){
				retorno= retorno + "(X=1, Y=0, Z=1); ";
			}
			if(e.getValoracao(true, true, false)){
				retorno= retorno + "(X=1, Y=1, Z=0); ";
			}
			if(e.getValoracao(true, true, true)){
				retorno= retorno + "(X=1, Y=1, Z=1); ";
			}
		}

		if(!retorno.equalsIgnoreCase("")){
			retorno = retorno.substring(0,retorno.length()-2);
		}
		
		return retorno;






	}



	public static void main(String[] args){

		Arquivo arquivo = new Arquivo("Expressoes.in","Expressoes.out");
		Principal p = new Principal();
		
		int contador = 1;
		arquivo.readInt();
		String lida = arquivo.readString();
		boolean primeiraVez = true;
		while(!arquivo.isEndOfFile()){
			if(primeiraVez){
				primeiraVez = false;
			}
			else{
				lida = arquivo.readString();
			}
			arquivo.println("Expressao "+ contador);
			if(!p.avaliarExpressao(lida)){
				arquivo.println("Expressao mal-formada");
			}
			else{
				Expressao e = p.criarExpressao(lida);
				arquivo.println("Expressao bem-formada");
				arquivo.println("Altura=" + e.altura());
				arquivo.println("Sub-expressoes=" + e.numeroSubExp());
				arquivo.println(p.valoracoes(e));
			}	
				arquivo.println("");
				contador++;
				
		}
	}


}



















